# VariableVerletIntegrator Class Reference

This is an error contolled, variable time step Integrator that simulates a System using the leap-frog Verlet algorithm. More...

`#include <VariableVerletIntegrator.h>`

Inheritance diagram for VariableVerletIntegrator:

List of all members.

## Public Member Functions

| VariableVerletIntegrator (double errorTol)
| Create a VariableVerletIntegrator.
double | getErrorTolerance () const
| Get the error tolerance.
void | setErrorTolerance (double tol)
| Set the error tolerance.
void | step (int steps)
| Advance a simulation through time by taking a series of time steps.
void | stepTo (double time)
| Advance a simulation through time by taking a series of steps until a specified time is reached.

## Protected Member Functions

void | initialize (ContextImpl &context)
| This will be called by the Context when it is created.
void | cleanup ()
| This will be called by the Context when it is destroyed to let the Integrator do any necessary cleanup.
std::vector< std::string > | getKernelNames ()
| Get the names of all Kernels used by this Integrator.
double | computeKineticEnergy ()
| Compute the kinetic energy of the system at the current time.

## Detailed Description

This is an error contolled, variable time step Integrator that simulates a System using the leap-frog Verlet algorithm.

It compares the result of the Verlet integrator to that of an explicit Euler integrator, takes the difference between the two as a measure of the integration error in each time step, and continuously adjusts the step size to keep the error below a specified tolerance. This both improves the stability of the integrator and allows it to take larger steps on average, while still maintaining comparable accuracy to a fixed step size integrator.

It is best not to think of the error tolerance as having any absolute meaning. It is just an adjustable parameter that affects the step size and integration accuracy. You should try different values to find the largest one that produces a trajectory sufficiently accurate for your purposes. 0.001 is often a good starting point.

Unlike a fixed step size Verlet integrator, variable step size Verlet is not symplectic. This means that at a given accuracy level, energy is not as precisely conserved over long time periods. This makes it most appropriate for constant temperate simulations. In constant energy simulations where precise energy conservation over long time periods is important, a fixed step size Verlet integrator may be more appropriate.

## Constructor & Destructor Documentation

VariableVerletIntegrator | ( | double | errorTol | ) | `[explicit]`

Create a VariableVerletIntegrator.

Parameters:

  | errorTol | the error tolerance

## Member Function Documentation

void cleanup | ( |  | ) | `[protected, virtual]`

This will be called by the Context when it is destroyed to let the Integrator do any necessary cleanup.

It will also get called again if the application calls reinitialize() on the Context.

Reimplemented from Integrator.

double computeKineticEnergy | ( |  | ) | `[protected, virtual]`

Compute the kinetic energy of the system at the current time.

Implements Integrator.

double getErrorTolerance | ( |  | ) | const`[inline]`

Get the error tolerance.

std::vector<std::string> getKernelNames | ( |  | ) | `[protected, virtual]`

Get the names of all Kernels used by this Integrator.

Implements Integrator.

void initialize | ( | ContextImpl & | context | ) | `[protected, virtual]`

This will be called by the Context when it is created.

It informs the Integrator of what context it will be integrating, and gives it a chance to do any necessary initialization. It will also get called again if the application calls reinitialize() on the Context.

Implements Integrator.

void setErrorTolerance | ( | double | tol | ) | `[inline]`

Set the error tolerance.

void step | ( | int | steps | ) | `[virtual]`

Advance a simulation through time by taking a series of time steps.

Parameters:

  | steps | the number of time steps to take

Implements Integrator.

void stepTo | ( | double | time | ) |

Advance a simulation through time by taking a series of steps until a specified time is reached.

When this method returns, the simulation time will exactly equal the time which was specified. If you call this method and specify a time that is earlier than the current time, it will return without doing anything.

Parameters:

  | time | the time to which the simulation should be advanced

The documentation for this class was generated from the following file:

- VariableVerletIntegrator.h